<?
/*
####################################################################
# Name: The Uniform Server Admin Panel 2.0 Language System Array 1.0
# Developed By: The Uniform Server Development Team
# Modified Last By: AlleyKat
# Web: http://www.uniformserver.com
####################################################################
*/

# Beta Feature, Currently For Debugging Only
#require_once 'array.php';

$US = array(
        'title' => 'Uniform Server',
        'apanel' => 'Admin Panel',
        'dev-team' => 'Uniform Server Udviklingsteamet',

        //--------------------------------------------------------------------------------------------
        // Navigation
        //--------------------------------------------------------------------------------------------

        // Basic
        'nav-home' => 'Hjem',
        // Start
        'nav-start' => 'Start Server',
        'nav-sserver' => 'Luk Server Ned',
        'nav-rmysql' => 'Kr MySQL',
        'nav-smysql' => 'Stop MySQL',
        'nav-rserver' => 'Genstart Services',
        // Configurations
        'nav-config' => 'Konfigurationer',
        'nav-aconfig' => 'Apache Konfiguration',
        'nav-pconfig' => 'PHP Konfiguration',
        // Tools Navigation
        'nav-tools' => 'Vrktjer',
        'nav-phpinfo' => 'phpinfo()',
        'nav-cgienv' => 'Perl milj',
        'nav-pma' => 'phpMyAdmin',
        'nav-pmbp' => 'phpMyBackupPro',
        'nav-status' => 'Apache Status',
        'nav-info' => 'Apache Info',
        'nav-vhost' => 'Admin Virtual Host',
        'nav-update' => 'Versionscheck',
        'nav-elog' => 'Error (fejl) Log Viser',
        'nav-u2w' => 'Unix - Win Converter',
        'nav-del' => 'Rens Server',
        'nav-down' => 'Download Manager',
        'nav-smig' => 'Server Migrering',
        // Plugins Navigation
        'nav-plugins' => 'Plugin Manager',
        'nav-pear' => 'Installr PEAR',
        // Misc Navigation
        'nav-misc' => 'Diverse',
        'nav-sup' => 'Online Support',
        // Documentation
        'nav-docs' => 'Dokumentationer',
        'nav-udoc' => 'Uniform Server Bruger Guide',
        'nav-sdoc' => 'Server Dokumentation',
        'nav-phdoc' => 'PHP Dokumentation',
        'nav-mydoc' => 'MySQL Dokumentation',
        'nav-pedoc' => 'Perl Dokumentation',
        // Languages
        'nav-langs' => 'Sprog',

        //--------------------------------------------------------------------------------------------
        // Home
        //--------------------------------------------------------------------------------------------

        'main-head' => 'Admin Panel '. $version .'',
        'main-text' => '
        Velkommen til Uniform Server '. $uniserver .'!. Dette er administrationssektion af serveren og
        du kan administrere din server fra dette Admin Panel.
            Selvom dette stadig er ALPHA versionen af dette panel, er det fuldt brugbart.
            Det er nemt at bruge og meget brugervenligt.
        <br />
        Opdateringer til denne oversttelse kan sendes til ap2langs@uniformserver.com
        <br />
          Bemrk at der er tilfjet nye ting, nogle ting er fjernet, og nogle funktioner virker muligvis ikke uden installation af en bestemt plugin eller funktion.
        <br />
        Alt feedback og fejl sendes til:
        <a href="mailto:dev@uniformserver.com">dev@uniformserver.com</a>
        eller post p vores <a href="http://forum.uniformserver.com/" target="_forum">forum</a>.
         <br />
        <br />
        Tak
         <br />
        <a href="http://www.uniformserver.com/" target="_home">The Uniform Server Development Team</a>',
        'main-secure' => 'Sikkerheds Checkliste',
        'main-text-0' => 'Skift username:password for Admin Panelet ved at redigere \'/htaccess/admin/home/www/.htpasswd\'',
        'main-text-1' => 'Skift username:password for serveren (hvis privat) ved at redigere \'/htaccess/www/.htpasswd\'',
        'main-text-2' => 'Skift root kodeordet i mysql ved at rette \'/home/admin/www/mysql_password\'',

        //--------------------------------------------------------------------------------------------
        // Update
        //--------------------------------------------------------------------------------------------

        'update-head' => 'Uniform Server Versions Check',
        'update-check' => 'Checker Version...',
        'update-true' => '
        Installeret version af Uniform Server er den seneste udgave.
        <br />
        Du behver ikke at opdatere.
        <br />',
        'update-false' => 'En nyere version af Uniform Sever er tilgngelig!',
        'update-new' => 'Ny Version',
        'update-yours' => 'Installeret Version',
        'update-get' => 'Du kan hente seneste version fra vores website ved at klikke linket herunder.',

        //--------------------------------------------------------------------------------------------
        // Server Shutdown
        //--------------------------------------------------------------------------------------------

        'stop-head' => 'Server Nedlukning',
        'stop-shut' => 'Verificr Nedlukning',
        'stop-killing' => 'Klik p Luk Ned! og serveren lukker ned.',
        'stop-stop' => 'Luk Ned!',

        //--------------------------------------------------------------------------------------------
        // Downlaod Manager
        //--------------------------------------------------------------------------------------------

        'down-head' => 'Download Manager',
        'down-aval' => 'Download tilgngelige opdateringer, plugins og addons.',
        'down-text' => '
        Under udvikling. Nr frdig kan du donwloade plugins,
        addons, og patches til din server. Der vil ogs vre selv-installerende installationspakker.',

        //--------------------------------------------------------------------------------------------
        // Apache Configuration
        //--------------------------------------------------------------------------------------------

        'aconfig-head' => 'Apache Konfiguration',
        'aconfig-conf' => 'Konfigurr Apache',
        'aconfig-sname' => 'Server Navn',
        'aconfig-wemail' => 'Server Admin Email',
        'aconfig-difiles' => 'Directory Index Files',
        'aconfig-ssi' => 'Server Side Includes',
        'aconfig-ssig' => 'Server Signatur',
        'aconfig-text-0' => 'noget',
        'aconfig-text-1' => '
        ndringerne er blevet gemt. <br /> De vil trde i kraft efter genstart af serveren!',
        'aconfig-save' => 'Gem',
        'aconfig-module' => 'I jeblikket er PHP loadet som Apache modul.',
        'aconfig-cgi' => 'I jeblikket afvikles PHP scripts igennem Apache CGI interfacet.',
        'aconfig-help' => '?',

        //--------------------------------------------------------------------------------------------
        // PHP Configuration
        //--------------------------------------------------------------------------------------------

        'pconfig-head' => 'PHP Konfiguration',
        'pconfig-conf' => 'Konfigure PHP',
        'pconfig-smode' => 'Safe Mode',
        'pconfig-rg' => 'Register Globals',
        'pconfig-mtexec' => 'Maksimal Script Afviklingstid (s.)',
        'pconfig-mmexec' => 'Maksimalt Hukommelsesforbrug (MB)',
        'pconfig-ssig' => 'Vis PHP I Server Signatur',
        'pconfig-perror' => 'Print Fejl',
        'pconfig-mpsize' => 'Maksimal Post Strrelse',
        'pconfig-musize' => 'Maksimal Upload Strrelse',
        'pconfig-text-0' => 'noget',
        'pconfig-text-1' => '
        ndringerne er gemt. <br /> De vil trde i kraft efter genstart af serveren!',
        'pconfig-save' => 'Gem',
        'pconfig-module' => 'I jeblikket er PHP loadet som Apache modul.',
        'pconfig-cgi' => 'I jeblikket afvikles PHP scripts igennem Apache CGI interfacet.',
        'pconfig-help' => '?',

        //--------------------------------------------------------------------------------------------
        // VHost Manager
        //--------------------------------------------------------------------------------------------

        'vhost-head' => 'Virtual Host',
        'vhost-setup' => 'Virtual Host Setup',
        'vhost-settings' => 'Virtual Host Indstillinger',
        'vhost-text-0' => 'Du har',
        'vhost-text-1' => 'hosts i din httpd.conf fil:',
        'vhost-text-2' => 'Fejl i hosts fil:',
        'vhost-text-3' => 'Alle hostnames findes i hosts filen!',
        'vhost-new' => '
        Brug dette nye tool til at tilfje flere virtual hosts til din server uden at skulle rette i httpd.conf filen selv.',
        'vhost-new-ex' => '(eks. newhost.localhost)',
        'vhost-name' => 'Navn:',
        'vhost-path' => 'Sti til DocumentRoot:',
        'vhost-path-ex' => '(eks. c:/www/newhost)',
        'vhost-opt' => 'Valgfrie extrating:',
        'vhost-opt-ex' => '(eks. error_log etc.)',
        'vhost-dne' => 'findes ikke',
        'vhost-make' => 'Opret VHost',
        'vhost-error-1' => 'Fejl i sti til din hosts-fil!',
        'vhost-error-2' => 'Fejl i sti til din httpd.conf!',
        'vhost-text-4' => 'Safe_mode er On, s genstart Apache manuelt!',
        'vhost-credit' => 'Script af Sukos',

        //--------------------------------------------------------------------------------------------
        // Server Migration
        //--------------------------------------------------------------------------------------------

        'smig-head' => 'Server Migrering',
        'smig-sub' => 'Migreringsvrktj [BETA FEATURE]',
        'smig-text-0' => 'Server Migreringsvrktjet hjlper dig med at flytte fra en server til en anden.
        Det hjlper dig med at flytte fra en anden server til denne server, eller migrere en gammel UniServer til denne.
        <br />
        <b>Scriptet skal kres via localhost for bedste resultater</b>',
        'smig-text-1' => 'Flgende er for WWW [htdocs] lokationen p den server du nsker at migrere.
        Du kan vlge kun at migrere en fil eller en mappe.',
        'smig-text-2' => 'Dette vil migrere din MySQL database fra den gamle server til denne server.
        Fr brug af denne del af scriptet, bemrk at der kan opst problemer hvis <b>du har samme databasenavn i den gamle installation og i denne</b>.',
        'smig-success' => 'Migrering gennemfrt! Du kan nu teste om det virker.',
        'smig-www' => 'WWW [htdocs] Lokation',
        'smig-mysql' => 'MySQL Data Mappe',
);

# Beta Feature, Currently For Debugging Only
#array2table($US, true);
?>