<?
/*
####################################################################
# Name: The Uniform Server Admin Panel 2.0 Language System Array 1.0
# Developed By: The Uniform Server Development Team
# Modified Last By: Christoph Ziegenberg (christoph@ziegenberg.com) 
# Web: http://www.uniformserver.com
####################################################################
*/

# Beta Feature, Currently For Debugging Only
#require_once 'array.php';

$US = array(
    	'title' => 'Uniform Server',
	'apanel' => 'Adminoberfl&#xE4;che',
	'dev-team' => 'Das Uniform Server Entwicklungs-Team',
	
	//--------------------------------------------------------------------------------------------
	// Navigation
	//--------------------------------------------------------------------------------------------
	
	// Basic
	'nav-home' => 'Start',
	// Start
	'nav-start' => 'Server starten',
	'nav-sserver' => 'Server stoppen',
	'nav-rmysql' => 'MySQL starten',
	'nav-smysql' => 'MySQL stoppen',
	'nav-rserver' => 'Dienste neustarten',
	// Configurations
	'nav-config' => 'Konfiguration',
	'nav-aconfig' => 'Apache Konfiguration',
	'nav-pconfig' => 'PHP Konfiguration',
	// Tools Navigation
	'nav-tools' => 'Tools',
	'nav-phpinfo' => 'phpinfo()',
	'nav-cgienv' => 'Perl Umgebung',
	'nav-pma' => 'phpMyAdmin',
	'nav-pmbp' => 'phpMyBackupPro',
	'nav-status' => 'Apache Status',
	'nav-info' => 'Apache Info',
	'nav-vhost' => 'Virtuelle Hosts verwalten',
	'nav-update' => 'Versionspr&#xFC;fung',
	'nav-elog' => 'Fehlerprotokoll anzeigen',
	'nav-u2w' => 'Unix - Win Converter',
	'nav-del' => 'Server bereinigen',
	'nav-down' => 'Download Manager',
	'nav-smig' => 'Server Migration',
	// Plugins Navigation
	'nav-plugins' => 'Plugin Manager',
	'nav-pear' => 'Pear installieren',
	// Misc Navigation
	'nav-misc' => 'Sonstiges',
	'nav-sup' => 'Online Hilfe',
	// Documentation
	'nav-docs' => 'Dokumentationen',
	'nav-udoc' => 'Uniform Server Benutzerhandbuch',
	'nav-sdoc' => 'Server Dokumentation',
	'nav-phdoc' => 'PHP Dokumentation',
	'nav-mydoc' => 'MySQL Dokumentation',
	'nav-pedoc' => 'Perl Dokumentation',
	// Languages
	'nav-langs' => 'Sprachen',
	
	//--------------------------------------------------------------------------------------------
	// Home
	//--------------------------------------------------------------------------------------------
	
	'main-head' => 'Adminoberfl&#xE4;che '. $version .'',
	'main-text' => '
	Willkommen zum Uniform Server '. $uniserver .'!. Dies ist der Administrationsbereich des Servers,  	
	mit dieser Oberfl&#xE4;che kannst du deinen Server verwalten. 
    	Auch wenn dies noch immer eine ALPHA Version der Adminoberfl&#xE4;che ist, so ist diese doch 
    	vollst&#xE4;ndig nutzbar. Sie ist au&#xDF;erdem einfach zu bedienen und benutzerfreundlich.
	<br />
	Du kannst diese Adminoberfl&#xE4;che auch einfach in deine eigene Sprache &#xFC;bersetzen. Wenn du dies tun 
	m&#xF6;chtest, sende bitte eine Kopie deiner &#xDC;bersetzung an ap2langs@uniformserver.com, damit wir diese 
	auch anderen zum Download anbieten k&#xF6;nnen.
	<br />
  	Zu erw&#xE4;hnen ist noch, dass neue Dinge hinzugef&#xFC;gt und andere entfernt wurden. Einige Funktionen 
	werden nicht funktionieren, wenn daf&#xFC;r ben&#xF6;tigte Plugins nicht installiert oder verf&#xFC;gbar sind.
	<br />
	Bitte sende alle Anmerkungen und Fehlermeldungen an: 
	<a href="mailto:dev@uniformserver.com">dev@uniformserver.com</a> 
	oder wende dich an unser <a href="http://forum.uniformserver.com/" target="_forum">Forum</a>.
 	<br />
	<br />
	Vielen Dank 
 	<br />
	<a href="http://www.uniformserver.com/" target="_home">Das Uniform Server Entwicklungs-Team</a>',
	'main-secure' => 'Sicherheits-Checkliste',
	'main-text-0' => '&#xC4;ndern Benutzernamen und Passwort f&#xFC;r die Adminoberfl&#xE4;che durch &#xC4;nderung der Datei \'/htaccess/admin/home/www/.htpasswd\'',
	'main-text-1' => '&#xC4;ndern Benutzernamen und Passwort f&#xFC;r den Server (wenn privat) durch &#xC4;nderung der Datei \'/htaccess/www/.htpasswd\'',
	'main-text-2' => '&#xC4;ndern des Root-Passworts f&#xFC;r MySQL durch &#xC4;nderung der Datei \'/home/admin/www/mysql_password\'',
	
	//--------------------------------------------------------------------------------------------
	// Update
	//--------------------------------------------------------------------------------------------
	
	'update-head' => 'Uniform Server Versionspr&#xFC;fung',
	'update-check' => '&#xDC;berpr&#xFC;fen der Version...',
	'update-true' => '
	Die installierte Version des Uniform Servers ist aktuell.
	<br />
	Eine Aktualisierung ist nicht notwendig.
	<br />',
	'update-false' => 'Eine aktuellere Version des Uniform Severs ist verf&#xFC;gbar!',
	'update-new' => 'Neue Version',
	'update-yours' => 'Installierte Version',
	'update-get' => 'Du kannst die aktuellste Version von unserer Webseite herunterladen oder durch Klicken des folgenden Links.',
	
	//--------------------------------------------------------------------------------------------
	// Server Shutdown
	//--------------------------------------------------------------------------------------------
	
	'stop-head' => 'Server stoppen',
	'stop-shut' => 'Stoppen des Servers best&#xE4;tigen',
	'stop-killing' => 'Bitte klicke auf Stoppen! und der Server wird automatisch gestoppt.',
	'stop-stop' => 'Stoppen!',
	
	//--------------------------------------------------------------------------------------------
	// Downlaod Manager
	//--------------------------------------------------------------------------------------------
	
	'down-head' => 'Download Manager',
	'down-aval' => 'Lade aktuelle Updates, Plugins und Erweiterungen herunter.',
	'down-text' => '
	Diese Funktion ist zur Zeit noch in der Entwicklung. Wenn es fertig gestellt ist, kannst du hier
	Plugins, Erweiterungen und Updates f&#xFC;r deinen Server herunterladen. Einige Funktionen werden sp&#xE4;ter  
	direkt installiert werden k&#xF6;nnen, andere m&#xFC;ssen von dir manuell installiert werden.',
	
	//--------------------------------------------------------------------------------------------
	// Apache Configuration
	//--------------------------------------------------------------------------------------------
	
	'aconfig-head' => 'Apache Konfiguration',
	'aconfig-conf' => 'Konfiguriere Apache',
	'aconfig-sname' => 'Server Name',
	'aconfig-wemail' => 'Server Admin Email',
	'aconfig-difiles' => 'Directory Index Files',
	'aconfig-ssi' => 'Server Side Includes',
	'aconfig-ssig' => 'Server Signatur',
	'aconfig-text-0' => 'etwas',
	'aconfig-text-1' => '
	Die &#xC4;nderungen wurden erfolgreich gespeichert.<br />Sie werden erst wirksam, nachdem der Server neu gestartet wurde!',
	'aconfig-save' => 'Speichern',
	'aconfig-module' => 'Zur Zeit ist PHP als Apache Modul geladen.',
	'aconfig-cgi' => 'Zur Zeit werden PHP Scripte &#xFC;ber das Apache CGI Interface ausgef&#xFC;hrt.',
	'aconfig-help' => '?',	

	//--------------------------------------------------------------------------------------------
	// PHP Configuration
	//--------------------------------------------------------------------------------------------
	
	'pconfig-head' => 'PHP Konfiguration',
	'pconfig-conf' => 'Konfiguriere PHP',
	'pconfig-smode' => 'Safe Mode',
	'pconfig-rg' => 'Register Globals',
	'pconfig-mtexec' => 'Maximale Ausf&#xFC;hrungszeit f&#xFC;r Scripte (Sek.)',
	'pconfig-mmexec' => 'Maxmale Speichermenge (MB)',
	'pconfig-ssig' => 'PHP in der Server-Signatur anzeigen',
	'pconfig-perror' => 'Fehlermeldungen ausgeben',
	'pconfig-mpsize' => 'Maximale Datenmenge f&#xFC;r POST-Daten',
	'pconfig-musize' => 'Maximale Datenmenge f&#xFC;r Dateiuploads',
	'pconfig-text-0' => 'etwas',
	'pconfig-text-1' => '
	Die &#xC4;nderungen wurden erfolgreich gespeichert.<br />Sie werden erst wirksam, nachdem der Server neu gestartet wurde!',
	'pconfig-save' => 'Speichern',
	'pconfig-module' => 'Zur Zeit ist PHP als Apache Modul geladen.',
	'pconfig-cgi' => 'Zur Zeit werden PHP Scripte &#xFC;ber das Apache CGI Interface ausgef&#xFC;hrt.',
	'pconfig-help' => '?',	

	//--------------------------------------------------------------------------------------------
	// VHost Manager
	//--------------------------------------------------------------------------------------------

	'vhost-head' => 'Virtuelle Hosts',
	'vhost-setup' => 'Einrichtung Virtueller Hosts',
	'vhost-settings' => 'Virtuelle Hosts Einstellungen',
	'vhost-text-0' => 'Du hast',
	'vhost-text-1' => 'Hosts in deiner httpd.conf Datei:',
	'vhost-text-2' => 'Fehler in der Hostdatei:',
	'vhost-text-3' => 'Alle Hostnamen existieren in der Hostdatei!',
	'vhost-new' => '
	Benutze dieses neue Tool, um weitere Host zu deinem Server hinzuzuf&#xFC;gen, ohne die 
	httpd.conf Datei selbst &#xE4;ndern zu m&#xFC;ssen.',
	'vhost-new-ex' => '(z.B. neuerhost.localhost)',
	'vhost-name' => 'Name:',
	'vhost-path' => 'Pfad zum DocumentRoot:',
	'vhost-path-ex' => '(z.B. c:/www/neuerhost)',
	'vhost-opt' => 'Optionale Erweiterungen:',
	'vhost-opt-ex' => '(z.B. error_log etc.)',
	'vhost-dne' => 'existiert nicht',
	'vhost-make' => 'Virtuellen Host erstellen',
	'vhost-error-1' => 'Fehler im Pfad zur Hostdatei!',
	'vhost-error-2' => 'Fahler im Pfad zur Datei httpd.conf!',
	'vhost-text-4' => 'Safe_mode ist aktiviert, bitte starte Apache manuell neu!',
	'vhost-credit' => 'Script von Sukos',

	//--------------------------------------------------------------------------------------------
	// Server Migration
	//--------------------------------------------------------------------------------------------

	'smig-head' => 'Server Migration',
	'smig-sub' => 'Migrations-Tool [BETA FUNKTION]',
	'smig-text-0' => 'Das Server Migrations-Tool hilft beim Wechsel von einem Server auf einen anderen.
	Es erlaubt dir die Migration von einem anderen Server auf diesen, auch die Migration von einer alten
	Uniform Server Installation.
	<br />
	<b>Dieses Script sollte am besten vom localhost aus ausgef&#xFC;hrt werden</b>',
	'smig-text-1' => 'Dies ist f&#xFC;r den Pfad zum WWW-Verzeichnis (htdocs) des zu migrierenden Servers. 
	Du kannst auch nur eine Datei oder ein bestimmtes Verzeichnis migrieren.',
	'smig-text-2' => 'Dies wird die MySQL Datenbank des alten Servers auf diesen Server migrieren.
	Bitte beachte vor Ausf&#xFC;hrung dieses Teils, dass <b>Problem auftreten k&#xF6;nnen, wenn du in der zu
	migrierenden Datenbank die gleichen Datenbanknamen verwendest, wie in dieser Installation</b>.',
	'smig-success' => 'Die Migration war erfolgreich! Bitte gehe zur&#xFC;ck und &#xFC;berpr&#xFC;fe die Daten.',
	'smig-www' => 'Pfad zum WWW-Verzeichnis (htdocs)',
	'smig-mysql' => 'Verzeichnis der MySQL Daten',
);  

# Beta Feature, Currently For Debugging Only
#array2table($US, true);
?>