<?
/*
####################################################################
# Name: The Uniform Server Admin Panel 2.0 Language System Array 1.0
# Developed By: The Uniform Server Development Team
# Modified Last By: Olajide Olaolorun (empirex) 
# Web: http://www.uniformserver.com
####################################################################
*/

# Beta Feature, Currently For Debugging Only
#require_once 'array.php';

$US = array(
    	'title' => 'Uniform Server',
	'apanel' => 'Admin Panel',
	'dev-team' => 'The Uniform Server Development Team',
	
	//--------------------------------------------------------------------------------------------
	// Navigation
	//--------------------------------------------------------------------------------------------
	
	// Basic
	'nav-home' => 'Home',
	// Start
	'nav-start' => 'Server Start',
	'nav-sserver' => 'Shutdown Server',
	'nav-rmysql' => 'Run MySQL',
	'nav-smysql' => 'Stop MySQL',
	'nav-rserver' => 'Restart Services',
	// Configurations
	'nav-config' => 'Configurations',
	'nav-aconfig' => 'Apache Configuration',
	'nav-pconfig' => 'PHP Configuration',
	// Tools Navigation
	'nav-tools' => 'Tools',
	'nav-phpinfo' => 'phpinfo()',
	'nav-cgienv' => 'Perl Envirnonments',
	'nav-pma' => 'phpMyAdmin',
	'nav-pmbp' => 'phpMyBackupPro',
	'nav-status' => 'Apache Status',
	'nav-info' => 'Apache Info',
	'nav-vhost' => 'Admin Virtual Host',
	'nav-update' => 'Version Check',
	'nav-elog' => 'Error Log Viewer',
	'nav-u2w' => 'Win - Unix Converter',
	'nav-del' => 'Clean Server',
	'nav-down' => 'Download Manager',
	'nav-smig' => 'Server Migration',
	// Plugins Navigation
	'nav-plugins' => 'Plugin Manager',
	'nav-pear' => 'Install Pear',
	// Misc Navigation
	'nav-misc' => 'Miscellaneous',
	'nav-sup' => 'Online Support',
	// Documentation
	'nav-docs' => 'Documentations',
	'nav-udoc' => 'Uniform Server User Guide',
	'nav-sdoc' => 'Server Documentation',
	'nav-phdoc' => 'PHP Documentation',
	'nav-mydoc' => 'MySQL Documentation',
	'nav-pedoc' => 'Perl Documentation',
	// Languages
	'nav-langs' => 'Languages',

	//--------------------------------------------------------------------------------------------
	// Home
	//--------------------------------------------------------------------------------------------
	
	'main-head' => 'Admin Panel '. $version .'',
	'main-text' => '
	Welcome to Uniform Server '. $uniserver .'!. This is the administration section of the server and 	
	you can administer your server from this Admin Panel. 
    	Though this is still the ALPHA version of this panel, it is fully useable 
    	and also complete. It is also easy to use and very user friendly.
	<br />
	You can also translate this Admin Panel into your own langauage easily, and if you will like to
	do so, please send a copy to ap2langs@uniformserver.com so we can add it for others to download.
	<br />
  	Also to add, new things as been added and some taken out and some functions may not 	
	work if the required plugin is not installed or available. 
	<br />
	All feedbacks and bugs should please be sent to: 
	<a href="mailto:dev@uniformserver.com">dev@uniformserver.com</a> 
	or posted on our <a href="http://forum.uniformserver.com/" target="_forum">forum</a>.
 	<br />
	<br />
	Thanks 
 	<br />
	<a href="http://www.uniformserver.com/" target="_home">The Uniform Server Development Team</a>',
	'main-secure' => 'Security Checklist',
	'main-text-0' => 'Change the username:password for the Admin Panel by editing \'/htaccess/home/admin/www/.htpasswd\'',
	'main-text-1' => 'Change the username:password for the server (if private) by editing \'/htaccess/www/.htpasswd\'',
	'main-text-2' => 'Change the root password for mysql by editing \'/home/admin/www/mysql_password\'',
	
	//--------------------------------------------------------------------------------------------
	// Update
	//--------------------------------------------------------------------------------------------
	
	'update-head' => 'Uniform Server Version Check',
	'update-check' => 'Checking Version...',
	'update-true' => '
	Installed version of the Uniform Server is the latest one.
	<br />
	You don\'t need to update it.
	<br />',
	'update-false' => 'A Newer version of the Uniform Sever is available!',
	'update-new' => 'New Version',
	'update-yours' => 'Installed Version',
	'update-get' => 'You can get the newer version from our website by clicking the link below.',
	
	//--------------------------------------------------------------------------------------------
	// Server Shutdown
	//--------------------------------------------------------------------------------------------
	
	'stop-head' => 'Server Shutdown',
	'stop-shut' => 'Varify Shutdown',
	'stop-killing' => 'Click on Shutdown! and the server will be automatically shut down.',
	'stop-stop' => 'Shutdown!',
	
	//--------------------------------------------------------------------------------------------
	// Downlaod Manager
	//--------------------------------------------------------------------------------------------
	
	'down-head' => 'Download Manager',
	'down-aval' => 'Download available updates, plugins, and addons.',
	'down-text' => '
	This feature is still in development and when it comes out you will be able to donwload plugins,
	addons, and patches for your server. Some features will also have a installer that allows you to
	automatically install them and some are going to be installed manually by you.',
	
	//--------------------------------------------------------------------------------------------
	// Apache Configuration
	//--------------------------------------------------------------------------------------------
	
	'aconfig-head' => 'Apache Configuration',
	'aconfig-conf' => 'Configure Apache',
	'aconfig-sname' => 'Server Name',
	'aconfig-wemail' => 'Server Admin Email',
	'aconfig-difiles' => 'Directory Index Files',
	'aconfig-ssi' => 'Server Side Includes',
	'aconfig-ssig' => 'Server Signature',
	'aconfig-text-0' => 'something',
	'aconfig-text-1' => '
	The changes have been sucssesfuly saved. <br /> The changes will have effect after restart of the server!',
	'aconfig-save' => 'Save',
	'aconfig-module' => 'At the moment PHP is loaded as Apache module.',
	'aconfig-cgi' => 'At the moment PHP scripts are executed though Apache CGI interface.',
	'aconfig-help' => '?',	

	//--------------------------------------------------------------------------------------------
	// PHP Configuration
	//--------------------------------------------------------------------------------------------
	
	'pconfig-head' => 'PHP Configuration',
	'pconfig-conf' => 'Configure PHP',
	'pconfig-smode' => 'Safe Mode',
	'pconfig-rg' => 'Register Globals',
	'pconfig-mtexec' => 'Maximum Script Execute Time (s.)',
	'pconfig-mmexec' => 'Maximum Memory Amount (MB)',
	'pconfig-ssig' => 'Show PHP In Server Signature',
	'pconfig-perror' => 'Print Errors',
	'pconfig-mpsize' => 'Maximum Post Size',
	'pconfig-musize' => 'Maximum Upload Size',
	'pconfig-text-0' => 'something',
	'pconfig-text-1' => '
	The changes have been sucssesfuly saved. <br /> The changes will have effect after restart of the server!',
	'pconfig-save' => 'Save',
	'pconfig-module' => 'At the moment PHP is loaded as Apache module.',
	'pconfig-cgi' => 'At the moment PHP scripts are executed though Apache CGI interface.',
	'pconfig-help' => '?',	

	//--------------------------------------------------------------------------------------------
	// VHost Manager
	//--------------------------------------------------------------------------------------------

	'vhost-head' => 'Virtual Host',
	'vhost-setup' => 'Virtual Host Setup',
	'vhost-settings' => 'Virtual Host Settings',
	'vhost-text-0' => 'You have',
	'vhost-text-1' => 'hosts in your httpd.conf file:',
	'vhost-text-2' => 'Error in hosts file:',
	'vhost-text-3' => 'All hostnames exist in hosts file!',
	'vhost-new' => '
	Use this new and cool tool to add more virtual hosts to your server without having to edit
	the httpd.conf file yourself.',
	'vhost-new-ex' => '(ex. newhost.localhost)',
	'vhost-name' => 'Name:',
	'vhost-path' => 'Path to DocumentRoot:',
	'vhost-path-ex' => '(ex. c:/www/newhost)',
	'vhost-opt' => 'Optional additions:',
	'vhost-opt-ex' => '(ex. error_log etc.)',
	'vhost-dne' => 'does not exist',
	'vhost-make' => 'Create VHost',
	'vhost-error-1' => 'Error in path to your hosts-file!',
	'vhost-error-2' => 'Error in path to your httpd.conf!',
	'vhost-text-4' => 'Safe_mode is On, so restart Apache manually!',
	'vhost-credit' => 'Script By Sukos',

	//--------------------------------------------------------------------------------------------
	// Server Migration
	//--------------------------------------------------------------------------------------------

	'smig-head' => 'Server Migration',
	'smig-sub' => 'Migration Tool [BETA FEATURE]',
	'smig-text-0' => 'The Server Migration tool helps you move from one server to another. 
	It allows you to migrate from another server to this server. It also allows you to migrate a old
	Uniform Server installation to this.
	<br />
	<b>This script must be ran via localhost for best result</b>',
	'smig-text-1' => 'The following is for the WWW [htdocs] location of the server you are trying to migrate. 
	You can chose to migrate only a file or a directory.',
	'smig-text-2' => 'This will migrate your MySQL database from the old servers to this server.
	Before using this part of the script, please not that <b>problems can occur if you have the same 
	database name in the old installtions and in this one</b>.',
	'smig-success' => 'The migration was successful! Please go and check to make sure now.',
	'smig-www' => 'WWW [htdocs] Location',
	'smig-mysql' => 'MySQL Data Directory',
);  

# Beta Feature, Currently For Debugging Only
#array2table($US, true);
?>