<?
/*
####################################################################
# Name: The Uniform Server Admin Panel 2.0 Language System Array 1.0
# Developed By: The Uniform Server Development Team
# Modified Last By: Klemens Hckel
# Web: http://www.uniformserver.com
####################################################################
*/

# Beta Feature, Currently For Debugging Only
#require_once 'array.php';

$US = array(
    	'title' => 'Uniform Server',
	'apanel' => 'Panel de Administracin',
	'dev-team' => 'El equipo de desarrollo de Uniform Server',

	//--------------------------------------------------------------------------------------------
	// Navigation
	//--------------------------------------------------------------------------------------------

	// Basic
	'nav-home' => 'Inicio',
	// Start
	'nav-start' => 'Iniciar servidor',
	'nav-sserver' => 'Parar servidor',
	'nav-rmysql' => 'Iniciar MySQL',
	'nav-smysql' => 'Parar MySQL',
	'nav-rserver' => 'Reiniciar servicios',
	// Configurations
	'nav-config' => 'Configuraciones',
	'nav-aconfig' => 'Configuracin Apache',
	'nav-pconfig' => 'Configuracin PHP',
	// Tools Navigation
	'nav-tools' => 'Herramientas',
	'nav-phpinfo' => 'phpinfo()',
	'nav-cgienv' => 'Entorno Perl',
	'nav-pma' => 'phpMyAdmin',
	'nav-pmbp' => 'phpMyBackupPro',
	'nav-status' => 'Apache Status',
	'nav-info' => 'Apache Info',
	'nav-vhost' => 'Admin Host Virtual',
	'nav-update' => 'Comprobar version',
	'nav-elog' => 'Visualizador de histrico de errores',
	'nav-u2w' => 'Conversor Unix - Win',
	'nav-del' => 'Servidor limpio',
	'nav-down' => 'Administrador de descargas',
	'nav-smig' => 'Migracin de servidor',
	// Plugins Navigation
	'nav-plugins' => 'Administrador de plugins',
	'nav-pear' => 'Instalar Pear',
	// Misc Navigation
	'nav-misc' => 'Miscelaneo',
	'nav-sup' => 'Supporte en linea',
	// Documentation
	'nav-docs' => 'Documentaciones',
	'nav-udoc' => 'Gua de usuario del Uniform Server',
	'nav-sdoc' => 'Documentacin del servidor',
	'nav-phdoc' => 'Documentacin PHP',
	'nav-mydoc' => 'Documentacin MySQL',
	'nav-pedoc' => 'Documentacin Perl',
	// Languages
	'nav-langs' => 'Idiomas',

	//--------------------------------------------------------------------------------------------
	// Home
	//--------------------------------------------------------------------------------------------

	'main-head' => 'Panel de Administracin '. $version .'',
	'main-text' => '
	Bienvenido al Uniform Server '. $uniserver .'!. Esto es el panel de administracin del servidor
	para administrar el servidor desde aqui.
    	A pesar de que el panel de control es todava una versin ALFA, es ya totalmente utilizable
    	y completo. Adems es amigable y fcil de usar.
	<br />
	Puedes tambin traducir este panel de Administracin fcilmente a tu idioma, y si lo haces por favor
	envia una copia a ap2langs@uniformserver.com para hacerlo disponible para que otros interesados se lo pueden bajar.
	<br />
  	Adems, nuevas funciones fueron agregados, y algunas eliminados, y algunas funciones podran
	dejar de funcionar si el plugin requerido no est instalado o disponible.
	<br />
	Opiniones, sugerencias, y reportes de bugs favor enviar a:
	<a href="mailto:dev@uniformserver.com">dev@uniformserver.com</a>
	o enviar a nuestro <a href="http://forum.uniformserver.com/" target="_forum">foro</a>.
 	<br />
	<br />
	Gracias
 	<br />
	<a href="http://www.uniformserver.com/" target="_home">El equipo de desarrollo del Uniform Server</a>',
	'main-secure' => 'Checklist de seguridad',
	'main-text-0' => 'Cambie el nombre de usuario:contrasea para el panel de administracin editando \'/htaccess/admin/home/www/.htpasswd\'',
	'main-text-1' => 'Cambie el nombre de usuario:contrasea del servidor (si privado) editando \'/htaccess/www/.htpasswd\'',
	'main-text-2' => 'Cambie contrasea de root de mysql editando \'/home/admin/www/mysql_password\'',

	//--------------------------------------------------------------------------------------------
	// Update
	//--------------------------------------------------------------------------------------------

	'update-head' => 'Comprobacin de Versin de Uniform Server',
	'update-check' => 'Comprobando versin...',
	'update-true' => '
	Ya est instalada la versin ms actual del Uniform Server.
	<br />
	No hay necesidad de actualizar.
	<br />',
	'update-false' => 'Est disponible una versin del Uniform Sever ms actualizada!',
	'update-new' => 'Versin nueva',
	'update-yours' => 'Versin instalada',
	'update-get' => 'Cliquee en el enlace abajo para descargar la versin ms actualizada desde nuestro sitio web.',

	//--------------------------------------------------------------------------------------------
	// Server Shutdown
	//--------------------------------------------------------------------------------------------

	'stop-head' => 'Parar Servidor',
	'stop-shut' => 'Verificar servidor parado',
	'stop-killing' => 'Pulse Parar! y se apagar automaticamente el servidor.',
	'stop-stop' => 'Parar!',

	//--------------------------------------------------------------------------------------------
	// Download Manager
	//--------------------------------------------------------------------------------------------

	'down-head' => 'Administrador de Descargas',
	'down-aval' => 'Descargue actualicaciones, plugins, y adicionales disponibles.',
	'down-text' => '
	Esta utilidad todava est en proceso de desarrollo y cuando se lance podrs descargar actualicaciones, plugins,
	adicionales, y parches para tu servidos. Algunos de ellos van a venir con instaladores para una
	instalacin automatica, otros que re requerrn instalacin y configuracin manual.',

	//--------------------------------------------------------------------------------------------
	// Apache Configuration
	//--------------------------------------------------------------------------------------------

	'aconfig-head' => 'Configuracin de Apache',
	'aconfig-conf' => 'Configurar Apache',
	'aconfig-sname' => 'Nombre del servidor',
	'aconfig-wemail' => 'Email del administrador del servidor',
	'aconfig-difiles' => 'Archivos del index de directorios',
	'aconfig-ssi' => 'Server Side Includes',
	'aconfig-ssig' => 'Server Signature',
	'aconfig-text-0' => 'algo',
	'aconfig-text-1' => '
	Los cambios se guardaron exitosamente. <br /> Los cambios tendrn efecto luego de reiniciar al servidor!',
	'aconfig-save' => 'Guardar',
	'aconfig-module' => 'Actualmente PHP est cargado como mdulo de Apache.',
	'aconfig-cgi' => 'Actualmente scripts de PHP se ejecutan a travs la interfaz CGI del Apache.',
	'aconfig-help' => '?',

	//--------------------------------------------------------------------------------------------
	// PHP Configuration
	//--------------------------------------------------------------------------------------------

	'pconfig-head' => 'Configuracin PHP',
	'pconfig-conf' => 'Configurar PHP',
	'pconfig-smode' => 'Modo seguro',
	'pconfig-rg' => 'Register Globals',
	'pconfig-mtexec' => 'Tiempo mxima de ejecucin de script (s.)',
	'pconfig-mmexec' => 'Mximo de memoria (MB)',
	'pconfig-ssig' => 'Mostrar PHP en firma del servidor',
	'pconfig-perror' => 'Imprimir erores',
	'pconfig-mpsize' => 'Tamao mximo para POST',
	'pconfig-musize' => 'Tamao mximo para Upload',
	'pconfig-text-0' => 'algo',
	'pconfig-text-1' => '
	Los cambios se guardaron exitosamente. <br /> Los cambios tendrn efecto luego de reiniciar al servidor!',
	'pconfig-save' => 'Guardar',
	'pconfig-module' => 'Actualmente PHP est cargado como mdulo de Apache.',
	'pconfig-cgi' => 'Actualmente scripts de PHP se ejecutan a travs la interfaz CGI del Apache.',
	'pconfig-help' => '?',

	//--------------------------------------------------------------------------------------------
	// VHost Manager
	//--------------------------------------------------------------------------------------------

	'vhost-head' => 'Host Virtual',
	'vhost-setup' => 'Configuracin de Host virtual',
	'vhost-settings' => 'Configuracin de Host virtual',
	'vhost-text-0' => 'Tienes',
	'vhost-text-1' => 'hosts en tu archivo httpd.conf:',
	'vhost-text-2' => 'Eror en el archivo de hosts:',
	'vhost-text-3' => 'Todos los nombres de hosts estn en el archivo de hosts!',
	'vhost-new' => '
	Use esta nueva herramienta para agregar ms hosts virtuales a tu servidor sin tener que editar
	el archivo httpd.conf mismo.',
	'vhost-new-ex' => '(ej. newhost.localhost)',
	'vhost-name' => 'Nombre:',
	'vhost-path' => 'Ruta a DocumentRoot:',
	'vhost-path-ex' => '(ej. c:/www/newhost)',
	'vhost-opt' => 'Adicionales opcionales:',
	'vhost-opt-ex' => '(ej. error_log etc.)',
	'vhost-dne' => 'no existe',
	'vhost-make' => 'Crear VHost',
	'vhost-error-1' => 'Eror de ruta a tu archivo de host!',
	'vhost-error-2' => 'Eror de ruta al archivo httpd.conf!',
	'vhost-text-4' => 'Modo seguro est habilitado, por lo tanto reinicie manualmente al Apache!',
	'vhost-credit' => 'Script hecho por Sukos',

	//--------------------------------------------------------------------------------------------
	// Server Migration
	//--------------------------------------------------------------------------------------------

	'smig-head' => 'Migracin de Servidor',
	'smig-sub' => 'Herramienta de migracin [BETA FEATURE]',
	'smig-text-0' => 'Esta herramienta de migracin de servidor ayuda a mudar de un servidor a otro.
	Permite migrar de otro servidor a este. Tambien permite migrar desde una instalacin anterior de
	Uniform Server a esta actual.
	<br />
	<b>Este script se debe ejecutar via localhost para mejores resultados</b>',
	'smig-text-1' => 'Lo siguiente es para la ubicacin de WWW [htdocs] del servidor que ests tratando de migrar.
	Puedes elegir para migrar solamente un archivo o un directorio.',
	'smig-text-2' => 'Esto va a migrar la base de datos MySQL del servidor anterior a este.
	Antes de usar esta parte del script te advertimos que <b>pueden ocurrir problemas si el nombre de la base de datos
	es igual en las dos instalaciones</b>.',
	'smig-success' => 'Migracin terminada exitosamente! Favor verifique ahora para estar seguro.',
	'smig-www' => 'Ubicacin WWW [htdocs]',
	'smig-mysql' => 'Directorio de los datos del MySQL',
);

# Beta Feature, Currently For Debugging Only
#array2table($US, true);
?>