<?
/*
####################################################################
# Name: The Uniform Server Admin Panel 2.0 Language System Array 1.0
# Developed By: The Uniform Server Development Team
# Modified Last By: Riccardo Rinco (r3g-ik) 
# Web: http://www.uniformserver.com
####################################################################
*/

# Beta Feature, Currently For Debugging Only
#require_once 'array.php';

$US = array(
    	'title' => 'Uniform Server',
	'apanel' => 'Pannello di Amministrazione',
	'dev-team' => 'The Uniform Server Development Team',
	
	//--------------------------------------------------------------------------------------------
	// Navigation
	//--------------------------------------------------------------------------------------------
	
	// Basic
	'nav-home' => 'Home',
	// Start
	'nav-start' => 'Avvia Server',
	'nav-sserver' => 'Arresta Server',
	'nav-rmysql' => 'Avvia MySQL',
	'nav-smysql' => 'Arresta MySQL',
	'nav-rserver' => 'Riavvia i Servizi',
	// Configurations
	'nav-config' => 'Configurazioni',
	'nav-aconfig' => 'Configurazione Apache',
	'nav-pconfig' => 'Configurazione PHP',
	// Tools Navigation
	'nav-tools' => 'Strumenti',
	'nav-phpinfo' => 'phpinfo()',
	'nav-cgienv' => 'Ambienti Perl',
	'nav-pma' => 'phpMyAdmin',
	'nav-pmbp' => 'phpMyBackupPro',
	'nav-status' => 'Stato di Apache',
	'nav-info' => 'Info di Apache',
	'nav-vhost' => 'Admin Virtual Host',
	'nav-update' => 'Controllo della Versione',
	'nav-elog' => 'Visualizzatore Error Log',
	'nav-u2w' => 'Convertitore Unix - Win',
	'nav-del' => 'Pulisci Server',
	'nav-down' => 'Gestore Download',
	'nav-smig' => 'Migrazione Server',
	// Plugins Navigation
	'nav-plugins' => 'Gestore Plugin',
	'nav-pear' => 'Installa Pear',
	// Misc Navigation
	'nav-misc' => 'Miscellanea',
	'nav-sup' => 'Supporto Online',
	// Documentation
	'nav-docs' => 'Documentazione',
	'nav-udoc' => 'Guida Utente ad Uniform Server',
	'nav-sdoc' => 'Documentazione Server',
	'nav-phdoc' => 'Documentazione PHP',
	'nav-mydoc' => 'Documentazione MySQL',
	'nav-pedoc' => 'Documentazione Perl',
	// Languages
	'nav-langs' => 'Lingue',
	
	//--------------------------------------------------------------------------------------------
	// Home
	//--------------------------------------------------------------------------------------------
	
	'main-head' => 'Panello di Amministrazione '. $version .'',
	'main-text' => '
	Benvenuto in Uniform Server '. $uniserver .'!. Questa  la sezione di amministrazione del server e 	
	puoi quindi amministrare il tuo server da questo Pannello di Amministrazione. 
    	Nonostante questa sia ancora la versione ALPHA del pannello,  totalmente usabile 
    	ed anche completa. E' inoltre facile da usare e veramente user friendly.
	<br />
	Puoi anche tradurre questo Pannello di Amministrazione nella tua lingua facilmente, e se vorrai
	farlo, ti preghiamo di spedirne una copia a ap2langs@uniformserver.com cos potremo aggiungerla perch altri la possano scaricare.
	<br />
  	C' da aggiungere che nuove cose sono state aggiunte ed alcune sono state tolte ed alcune funzioni potrebbero non 	
	funzionare se il plugin richiesto non  installato o non  disponibile. 
	<br />
	Tutti i feedbacks e le segnalazioni di bug devono essere inviate a: 
	<a href="mailto:dev@uniformserver.com">dev@uniformserver.com</a> 
	o postate sul nostro <a href="http://forum.uniformserver.com/" target="_forum">forum</a>.
 	<br />
	<br />
	Grazie 
 	<br />
	<a href="http://www.uniformserver.com/" target="_home">The Uniform Server Development Team</a>',
	'main-secure' => 'Security Checklist',
	'main-text-0' => 'Change the username:password for the Admin Panel by editing \'/htaccess/admin/home/www/.htpasswd\'',
	'main-text-1' => 'Change the username:password for the server (if private) by editing \'/htaccess/www/.htpasswd\'',
	'main-text-2' => 'Change the root password for mysql by editing \'/home/admin/www/mysql_password\'',
	
	//--------------------------------------------------------------------------------------------
	// Update
	//--------------------------------------------------------------------------------------------
	
	'update-head' => 'Controlla la Versione di Uniform Server',
	'update-check' => 'Controllando la Versione...',
	'update-true' => '
	La vesrione installata di Uniform Server  la pi aggiornata.
	<br />
	Non hai bisogno di aggiornarla.
	<br />',
	'update-false' => 'E' disponibile una Nuova versione di Uniform Sever!',
	'update-new' => 'Nuova Versione',
	'update-yours' => 'Versione Installata',
	'update-get' => 'Puoi scaricare la nuova versione dal nostro sito web cliccando sul link sottostante.',
	
	//--------------------------------------------------------------------------------------------
	// Server Shutdown
	//--------------------------------------------------------------------------------------------
	
	'stop-head' => 'Arresto Server',
	'stop-shut' => 'Verifica Arresto',
	'stop-killing' => 'Clicca su Arresta! ed il server verr automaticamente arrestato.',
	'stop-stop' => 'Arresta!',
	
	//--------------------------------------------------------------------------------------------
	// Downlaod Manager
	//--------------------------------------------------------------------------------------------
	
	'down-head' => 'Gestore Download',
	'down-aval' => 'Download aggiornamenti, plugin, ed addon disponibili.',
	'down-text' => '
	Questa caratteristica  ancora in sviluppo e quando sar rilasciata potrai scaricare plugins,
	addon, e patch per il tuo server. Alcune caratteristiche avranno anche un'installer che ti permetter di
	installarle automaticamente e alcune stanno per essere installate manualmente da te.',
	
	//--------------------------------------------------------------------------------------------
	// Apache Configuration
	//--------------------------------------------------------------------------------------------
	
	'aconfig-head' => 'Configurazione Apache',
	'aconfig-conf' => 'Configura Apache',
	'aconfig-sname' => 'Nome Server',
	'aconfig-wemail' => 'Email Amministratore Server',
	'aconfig-difiles' => 'Directory Index Files',
	'aconfig-ssi' => 'Server Side Includes',
	'aconfig-ssig' => 'Firma Server',
	'aconfig-text-0' => 'qualcosa',
	'aconfig-text-1' => '
	I cambiamenti sono stati salvati con successo. <br /> I cambiamenti avranno effetto dopo il riavvio del server!',
	'aconfig-save' => 'Salva',
	'aconfig-module' => 'Al momento PHP  caricato come modulo di Apache.',
	'aconfig-cgi' => 'Al momneto gli script PHP sono eseguiti attraverso l'interfaccia CGI di Apache.',
	'aconfig-help' => '?',	

	//--------------------------------------------------------------------------------------------
	// PHP Configuration
	//--------------------------------------------------------------------------------------------
	
	'pconfig-head' => 'Configurazione PHP',
	'pconfig-conf' => 'Configura PHP',
	'pconfig-smode' => 'Safe Mode',
	'pconfig-rg' => 'Register Globals',
	'pconfig-mtexec' => 'Tempo Massimo di Esecuzione degli Script (s.)',
	'pconfig-mmexec' => 'Ammonstare Massimo della Memoria (MB)',
	'pconfig-ssig' => 'Mostra PHP Nella Firma del Server',
	'pconfig-perror' => 'Stampa Errori',
	'pconfig-mpsize' => 'Grandezza Massima Post',
	'pconfig-musize' => 'Grandezza Massima Upload',
	'pconfig-text-0' => 'qualcosa',
	'pconfig-text-1' => '
	I cambiamenti sono stati salvati con successo. <br /> I cambiamenti avranno effetto dopo il riavvio del server!',
	'pconfig-save' => 'Salva',
	'pconfig-module' => 'Al momento PHP  caricato come modulo di Apache.',
	'pconfig-cgi' => 'Al momneto gli script PHP sono eseguiti attraverso l'interfaccia CGI di Apache.',
	'pconfig-help' => '?',	

	//--------------------------------------------------------------------------------------------
	// VHost Manager
	//--------------------------------------------------------------------------------------------

	'vhost-head' => 'Virtual Host',
	'vhost-setup' => 'Setup Virtual Host',
	'vhost-settings' => 'Impostazioni Virtual Host',
	'vhost-text-0' => 'Hai',
	'vhost-text-1' => 'host nel tuo file httpd.conf:',
	'vhost-text-2' => 'Errore nel file hosts:',
	'vhost-text-3' => 'Tutti gli hostnames esistono nel file hosts!',
	'vhost-new' => '
	Usa questo nuovo strumento per aggiungere pi virtual host al tuo server senza dover modificare
	il file httpd.conf da solo.',
	'vhost-new-ex' => '(ex. nuovohost.localhost)',
	'vhost-name' => 'Nome:',
	'vhost-path' => 'Percorso alla DocumentRoot:',
	'vhost-path-ex' => '(ex. c:/www/nuovohost)',
	'vhost-opt' => 'Aggiunte opzionali:',
	'vhost-opt-ex' => '(ex. error_log etc.)',
	'vhost-dne' => 'non esiste',
	'vhost-make' => 'Crea VHost',
	'vhost-error-1' => 'Errore nel percorso al tuo file hosts!',
	'vhost-error-2' => 'Errore nel percorso al tuo httpd.conf!',
	'vhost-text-4' => 'Safe_mode  impostato come On, quindi riavvia Apache manualmente!',
	'vhost-credit' => 'Script di Sukos',

	//--------------------------------------------------------------------------------------------
	// Server Migration
	//--------------------------------------------------------------------------------------------

	'smig-head' => 'Migrazione Server',
	'smig-sub' => 'Strumento di Migrazione [CARATTERISTICA IN BETA]',
	'smig-text-0' => 'Lo strumento di Migrazione del Server ti aiuta a muoverti da un server all'altro. 
	Ti permette di migrare da un'altro server verso questo. Ti permette inoltre di migrare da una vecchia
	installazione di Uniform Server a questa.
	<br />
	<b>Questo script deve essere eseguito via localhost per ottenere il miglior risultato</b>',
	'smig-text-1' => 'Il seguente  per la posizione della WWW [htdocs] del server che stai cercando di migrare. 
	Puoi scegliere di migrare solo un file o una cartella.',
	'smig-text-2' => 'Questo migrer il tuo database MySQL dal vecchio server a questo server.
	Prima di usare questa parte di script, per favore considera che <b>potrebbero essere riscontrati problemi se hai lo stesso 
	nome per database della vecchia installazione e di questa</b>.',
	'smig-success' => 'La migrazione  avvenuta con successo! Per favore ora controlla per esserne sicuro.',
	'smig-www' => 'WWW [htdocs] Location',
	'smig-mysql' => 'MySQL Data Directory',
);  

# Beta Feature, Currently For Debugging Only
#array2table($US, true);
?>